SystemOrganization addCategory: #Figures!

Object subclass: #HeartFigure
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Figures'!

!HeartFigure methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/27/2013 13:35'!
dtAtT: aNumber
"dt/dl = 1/sqrt(2304*sin(t)^4*cos(t) ^2 + 169*cos(t)^2 + 100*sin(2t)^2 + 36*sin(3t)^2 + 16*sin(4t)^2+260*cos(t)*sin(2t) - 156*cos(t)*sin(3t) -104*cos(t)*sin(4t)-120*sin(2t)*sin(3t) -80*sin(2t)*sin(4t)+48*sin(3t)*sin(4t))"
	|sint cost sin2t sin3t sin4t sint4 cost2 sin2t2 sin3t2 sin4t2|
	sint := aNumber sin.
	cost := aNumber cos.
	sin2t := (aNumber * 2) sin.
	sin3t := (aNumber * 3) sin.
	sin4t := (aNumber * 4) sin.
	sint4 := sint raisedToInteger: 4.
	cost2 := cost squared.
	sin2t2 := sin2t squared.
	sin3t2 := sin3t squared.
	sin4t2 := sin4t squared.
	
	^((2304*sint4*cost2) + (169*cost2) + (100*sin2t2) + 36*sin3t2 + (16*sin4t2) + (260*cost*sin2t) - (156*cost*sin3t) - (104*cost*sin4t) - (120*sin2t*sin3t) - (80*sin2t*sin4t) + (48*sin3t*sin4t)) reciprocal! !

!HeartFigure methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/27/2013 14:03'!
forWidth: anInteger 
	self makePointsOfNumber: (anInteger/4) truncated! !

!HeartFigure methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/27/2013 13:56'!
makePointsOfNumber: anInteger 
	points := (0 to: Float pi * 2 by:  Float pi * 2 / anInteger) collect: [:t| |x y|
		x := 16*((t sin) raisedToInteger: 3).
		y := 13*(t cos) - (5 * ((2*t) cos)) - (2*((3*t) cos)) - ((4*t) cos).
		((x@y negated) + (16@12.5))/32
	].! !

!HeartFigure methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/27/2013 12:19'!
points
	^points! !

Object subclass: #RoundedCornerRectangle
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Figures'!

!RoundedCornerRectangle methodsFor: 'accessing' stamp: 'HwaJong 3/1/2013 10:41'!
points
	^points! !

!RoundedCornerRectangle methodsFor: 'creating' stamp: 'HwaJong 3/1/2013 14:50'!
rectangle: aRectangle cornerRadius: anInteger 
	|x0 y0|
	x0 := anInteger@0.
	y0 := 0@anInteger.
	points :=
		Array streamContents: [:stream|
			[:startPi :rotCenter| 
				|endPi|
				endPi := startPi + 0.5.
				(Float pi * startPi to: Float pi * endPi by: (anInteger) reciprocal) do: 
					[:theta| stream nextPut: (((theta cos @ theta sin) * anInteger) + rotCenter) rounded]]
				value: 0.0 value: (aRectangle bottomRight - x0 - y0);
				value: 0.5 value: (aRectangle bottomLeft + x0 - y0);
				value: 1.0 value: (aRectangle topLeft + x0 + y0);
				value: 1.5 value: (aRectangle topRight - x0 + y0).
			]! !
